// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];
var snsridHasIPMI =            parent.asID['DUMMY_SENSORID_HASIPMI'];

var snridMBTemperature1 =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridMBTemperature2 =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0150;
var snridCPU1Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0200;
var snridCPU2Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0300;
var snridCPU1Temperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0210;
var snridCPU2Temperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0310;
var snridFBDCh0Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0400;
var snridFBDCh0Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0410;
var snridFBDCh0Slot2Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0420;
var snridFBDCh1Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0440;
var snridFBDCh1Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0450;
var snridFBDCh1Slot2Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0460;
var snridFBDCh2Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0480;
var snridFBDCh2Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0490;
var snridFBDCh2Slot2Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04A0;
var snridFBDCh3Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04C0;
var snridFBDCh3Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04D0;
var snridFBDCh3Slot2Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04E0;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;
var snridVcore2Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0120;

var snridFan8Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0180;
var snridFan9Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0190;
var snridHotFan1Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3110;
var snridHotFan2Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3120;
var snridHotFan3Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3130;
var snridHotFan4Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3140;
var snridHotFan5Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3150;
var snridHotFan6Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3160;
var snridHotFan7Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3170;

var snridBkpl1Bay1Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1110;
var snridBkpl1Bay2Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1120;
var snridBkpl1Bay3Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1130;
var snridBkpl1Bay4Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1140;
var snridBkpl1Bay5Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1150;
var snridBkpl1Bay6Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1160;
var snridBkpl1Bay7Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1170;
var snridBkpl1Bay8Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1180;

var snridPower1Plug =          (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x2110;
var snridPower2Plug =          (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x2210;
var snridPower1AC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2120;
var snridPower2AC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2220;
var snridPowerFan1 =           (parent.asID['ASWM_SNRTYPE_POWERFANSTATUS'] << 16) + 0x2130;
var snridPowerFan2 =           (parent.asID['ASWM_SNRTYPE_POWERFANSTATUS'] << 16) + 0x2230;


var compPCI = new SysComponentInfo ('RISER2', "parent.I18N['RISERBOARD']", 'info_riser2.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 4, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 4, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 7).extra", snsridHasDMI)
    )
);
var compRiser = new SysComponentInfo ('RISER1', "parent.I18N['RISERBOARD']", 'info_riser1.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 3, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 3, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 7).extra", snsridHasDMI)
    )
);
var compBackplaneBoard = new SysComponentInfo ('BACKPLANEBOARD', "parent.I18N['BACKPLANE']", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "'BP8LX-R22'", snsridHasFRU)
    )
);

var compHotFan1 = new SysComponentInfo ('HOTFAN1', "parent.once.GSensorNames[parent.once.snridHotFan1Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan1Speed).unit]", snridHotFan1Speed)
    )
);
var compHotFan2 = new SysComponentInfo ('HOTFAN2', "parent.once.GSensorNames[parent.once.snridHotFan2Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan2Speed).unit]", snridHotFan2Speed)
    )
);
var compHotFan3 = new SysComponentInfo ('HOTFAN3', "parent.once.GSensorNames[parent.once.snridHotFan3Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan3Speed).unit]", snridHotFan3Speed)
    )
);
var compHotFan4 = new SysComponentInfo ('HOTFAN4', "parent.once.GSensorNames[parent.once.snridHotFan4Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan4Speed).unit]", snridHotFan4Speed)
    )
);
var compHotFan5 = new SysComponentInfo ('HOTFAN5', "parent.once.GSensorNames[parent.once.snridHotFan5Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan5Speed).unit]", snridHotFan5Speed)
    )
);
var compHotFan6 = new SysComponentInfo ('HOTFAN6', "parent.once.GSensorNames[parent.once.snridHotFan6Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan6Speed).unit]", snridHotFan6Speed)
    )
);
var compHotFan7 = new SysComponentInfo ('HOTFAN7', "parent.once.GSensorNames[parent.once.snridHotFan7Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan7Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan7Speed).unit]", snridHotFan7Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.theSysInfo.quadrupleExtraAt(9)", "parent.once.theSysInfo.pairAt(9)"),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature2]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature2).unit]", snridMBTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).unit]", snridCPU1Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).unit]", snridCPU2Temperature2)
    )
);
var compMemory, compMemory2;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr1.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot2Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot2Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot2Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot2Temperature)")
        )
    );
    compMemory2 = new SysComponentInfo ('DIMM2', "parent.I18N['RAMMODULE']", 'info_ddr2.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 9, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 9, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 9, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 9, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot2Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot2Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 10, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 10, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 10, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 10, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 11, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 11, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 11, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 11, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 12, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 12, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 12, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 12, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot2Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot2Temperature)")
        )
    );
} else {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr1.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 5, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 5, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 6, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 6, 9).value)", snsridHasDMI),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot0Temperature).unit]", snridFBDCh0Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot1Temperature).unit]", snridFBDCh0Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot2Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot2Temperature).unit]", snridFBDCh0Slot2Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot0Temperature).unit]", snridFBDCh1Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot1Temperature).unit]", snridFBDCh1Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot2Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot2Temperature).unit]", snridFBDCh1Slot2Temperature)
        )
    );
    compMemory2 = new SysComponentInfo ('DIMM2', "parent.I18N['RAMMODULE']", 'info_ddr2.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 7, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 7, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 8, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 8, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 9, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 9, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 10, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 10, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 11, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 11, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 12, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 12, 9).value)", snsridHasDMI),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot0Temperature).unit]", snridFBDCh2Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot1Temperature).unit]", snridFBDCh2Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot2Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot2Temperature).unit]", snridFBDCh2Slot2Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot0Temperature).unit]", snridFBDCh3Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot1Temperature).unit]", snridFBDCh3Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot2Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot2Temperature).unit]", snridFBDCh3Slot2Temperature)
        )
    );
}
var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).unit]", snridCPU1Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);
var compCPU2 = new SysComponentInfo ('CPU2', "parent.I18N['CPU'] + ' 2'", 'info_cpu2.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 2, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 2, 13).value + 'Mhz'", snridVcore2Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).unit]", snridCPU2Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore2Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).unit]", snridVcore2Voltage)
    )
);

var compBackplane = new SysComponentInfo ('BACKPLANE', "parent.I18N['BACKPLANE']",
    new SysCompositeImage (
        'IBACKPLANE1',
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"30\\" height=\\"205\\" rowspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f01.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"206\\" height=\\"85\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"34\\" height=\\"205\\" rowspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD><TABLE WIDTH=\\"206\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"60\\" height=\\"39\\">"',
            '"       <TABLE WIDTH=\\"60\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\" >"',
            '"       <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay1Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"       <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay2Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"       <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay3Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"       </TABLE></TD>"',
            '"    <TD><IMG SRC=\\"" + parent.once.imgPath + "hd_f05.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD><TABLE WIDTH=\\"60\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\" >"',
            '"        <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f06.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay4Plug).currvalue == 1 ? "hd_ok" : "hd_no_M") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay5Plug).currvalue == 1 ? "hd_ok" : "hd_no_M") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        </TABLE></TD>"',
            '"    <TD><IMG SRC=\\"" + parent.once.imgPath + "hd_f07.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD><TABLE WIDTH=\\"60\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\" >"',
            '"        <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay6Plug).currvalue == 1 ? "hd_ok" : "hd_no_R") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay7Plug).currvalue == 1 ? "hd_ok" : "hd_no_R") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay8Plug).currvalue == 1 ? "hd_ok" : "hd_no_R") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        </TABLE></TD></TR></TABLE></TD></TR>"',
            '"<TR><TD WIDTH=\\"206\\" height=\\"81\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['HARDDISK_NUMBER']",
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay2Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay3Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay4Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay5Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay6Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay7Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay8Plug).currvalue",
            snsridHasFRU
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE1_BAY1',
            new triple (new Point (9, 85), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 13),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay1Plug)
        ),
        new triple ('IALARM_BACKPLANE1_BAY2',
            new triple (new Point (9, 98), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 11),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay2Plug)
        ),
        new triple ('IALARM_BACKPLANE1_BAY3',
            new triple (new Point (9, 112), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 9),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay3Plug)
        ),
        new triple ('IALARM_BACKPLANE2_BAY1',
            new triple (new Point (100, 98), '"<img src=\\"" + parent.once.imgPath + "hd_M_e.gif\\">"', 13),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay4Plug)
        ),
        new triple ('IALARM_BACKPLANE2_BAY2',
            new triple (new Point (100, 112), '"<img src=\\"" + parent.once.imgPath + "hd_M_e.gif\\">"', 11),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay5Plug)
        ),
        new triple ('IALARM_BACKPLANE3_BAY1',
            new triple (new Point (178, 85), '"<img src=\\"" + parent.once.imgPath + "hd_R_e.gif\\">"', 13),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay6Plug)
        ),
        new triple ('IALARM_BACKPLANE3_BAY2',
            new triple (new Point (178, 98), '"<img src=\\"" + parent.once.imgPath + "hd_R_e.gif\\">"', 11),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay7Plug)
        ),
        new triple ('IALARM_BACKPLANE3_BAY3',
            new triple (new Point (178, 112), '"<img src=\\"" + parent.once.imgPath + "hd_R_e.gif\\">"', 9),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay8Plug)
        )
    )
);

var compPowerFan1 = new SysComponentInfo ('PWRFAN1', "parent.once.GSensorNames[parent.once.snridPowerFan1]", 'info_powerFan.jpg',
    new Tuple (
        new triple ("parent.I18N['STATUS']", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan1))", snridPowerFan1)
    )
);

var compPowerFan2 = new SysComponentInfo ('PWRFAN2', "parent.once.GSensorNames[parent.once.snridPowerFan2]", 'info_powerFan.jpg',
    new Tuple (
        new triple ("parent.I18N['STATUS']", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan2))", snridPowerFan2)
    )
);

var compRedundantPower = new SysComponentInfo ('RDTPOWER', "parent.I18N['POWER']",
    new SysCompositeImage (
        'IPOWER',
        new Tuple(
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"70\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_01.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"79\\" height=\\"82\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"105\\" height=\\"82\\">"',
            '"    <TABLE WIDTH=\\"105\\" height=\\"82\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"    <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridPower1Plug).currvalue == 1 ? "power_ok" : "power_noUp") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"    <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridPower2Plug).currvalue == 1 ? "power_ok" : "power_noDn") + ".gif\\" BORDER=\\"0\\"></TD></TR></TABLE></TD>"',
            '"    <TD WIDTH=\\"86\\" height=\\"82\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"53\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['POWERMODULE'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1Plug))", snridPower1Plug),
        new triple ("parent.I18N['POWERMODULE'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2Plug))", snridPower2Plug),
        new triple ("parent.I18N['POWER_FAN'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan1))", snridPowerFan1),
        new triple ("parent.I18N['POWER_FAN'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan2))", snridPowerFan2),
        new triple ("parent.I18N['POWERCORD'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1AC))", snridPower1AC),
        new triple ("parent.I18N['POWERCORD'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2AC))", snridPower2AC)
    ),
    new Tuple (
        new triple ('IALARM_POWERPLUG_UP',
            new triple (new Point (70, 70), '"<img src=\\"" + parent.once.imgPath + "power_e.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower1Plug)
        ),
        new triple ('IALARM_POWERPLUG_DOWN',
            new triple (new Point (70, 112), '"<img src=\\"" + parent.once.imgPath + "power_e.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower2Plug)
        ),
        new triple ('IALARM_POWERAC_UP',
            new triple (new Point (70, 70), '"<img src=\\"" + parent.once.imgPath + "plug_e.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower1AC)
        ),
        new triple ('IALARM_POWERAC_DOWN',
            new triple (new Point (70, 112), '"<img src=\\"" + parent.once.imgPath + "plug_e.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower2AC)
        )
    )
);


var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var compIPMI = new SysComponentInfo ('IPMI', "'IPMI'",
    new SysCompositeImage (
        'IPMI',
        new Tuple (
            '"<img src=\\"" + parent.once.imgPath + (parent.once.findIPMI(parent.once.theASMAInfo, 16) ? "info_ipmi_2.jpg" : "info_ipmi.jpg") + "\\">"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['IPMI_CARDTYPE']", "parent.once.findIPMI(parent.once.theASMAInfo, 16)", snsridHasIPMI)
    )
);


var theSystemComponents = new Tuple (
    compRedundantPower,
    compPowerFan1,
    compPowerFan2,
    compBackplane,
    compBackplaneBoard,
    compIOConnector,
    compHotFan1,
    compHotFan2,
    compHotFan3,
    compHotFan4,
    compHotFan5,
    compHotFan6,
    compHotFan7,
    compMotherboard,
    compIPMI,
    compPCI,
    compRiser,
    compMemory,
    compMemory2,
    compCPU1,
    compCPU2
);

//////////////////////////////////////////////
// The System with Views

var imgPath = './img/rs260-e4_rx8/';
var theSystem = new SysModel ('model.jpg', chassis_rackmount);
var imgPanelFront = 'main_front.gif';
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 27, 169, 266, 216), compBackplane)
        ),
        new Tuple (
            new quadruple ('AL_BACKPLANE1', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (136, 184))
        )
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 66,  76,  77,  99), compIPMI),
            new AnArea (new Rect ( 34, 163, 153, 168), compBackplaneBoard),
            new AnArea (new Rect ( 34, 169, 153, 216), compBackplane),
            new AnArea (new Rect (125,  13, 138,  25), compPowerFan1),
            new AnArea (new Rect (139,  13, 152,  25), compPowerFan2),
            new AnArea (new Rect (123,  17, 154, 107), compRedundantPower),
            new AnArea (new Rect ( 28, 140,  61, 154), compHotFan1),
            new AnArea (new Rect ( 59, 140,  91, 154), compHotFan2),
            new AnArea (new Rect ( 90, 140, 123, 154), compHotFan3),
            new AnArea (new Rect ( 28, 127,  61, 141), compHotFan4),
            new AnArea (new Rect ( 59, 127,  91, 141), compHotFan5),
            new AnArea (new Rect ( 90, 127, 123, 141), compHotFan6),
            new AnArea (new Rect (122, 140, 154, 154), compHotFan7),
            new AnArea (new Rect ( 39,  34,  44,  71), compPCI),
            new AnArea (new Rect ( 61,  33,  66,  75), compRiser),
            new AnArea (new Rect ( 99,  32, 120,  74), compMemory),
            new AnArea (new Rect ( 68,  31,  89,  73), compMemory2),
            new AnArea (new Rect (101,  81, 119,  97), compCPU1),
            new AnArea (new Rect ( 77,  81,  96,  98), compCPU2),
            new AnArea (new Rect ( 39,  23, 122, 115), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_POWERS', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_POWERS'], new Point (129, 54)),
            new quadruple ('AL_POWERFAN1', parent.asID['IDV_TYPE_SNR'], snridPowerFan1, new Point (122, 11)),
            new quadruple ('AL_POWERFAN2', parent.asID['IDV_TYPE_SNR'], snridPowerFan2, new Point (136, 11)),
            new quadruple ('AL_HOTFAN1', parent.asID['IDV_TYPE_SNR'], snridHotFan1Speed, new Point (35, 139)),
            new quadruple ('AL_HOTFAN2', parent.asID['IDV_TYPE_SNR'], snridHotFan2Speed, new Point (66, 139)),
            new quadruple ('AL_HOTFAN3', parent.asID['IDV_TYPE_SNR'], snridHotFan3Speed, new Point (97, 139)),
            new quadruple ('AL_HOTFAN4', parent.asID['IDV_TYPE_SNR'], snridHotFan4Speed, new Point (35, 126)),
            new quadruple ('AL_HOTFAN5', parent.asID['IDV_TYPE_SNR'], snridHotFan5Speed, new Point (66, 126)),
            new quadruple ('AL_HOTFAN6', parent.asID['IDV_TYPE_SNR'], snridHotFan6Speed, new Point (97, 126)),
            new quadruple ('AL_HOTFAN7', parent.asID['IDV_TYPE_SNR'], snridHotFan7Speed, new Point (130, 139)),
            new quadruple ('AL_FBDC0S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot0Temperature, new Point (101, 45)),
            new quadruple ('AL_FBDC0S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot1Temperature, new Point (101, 45)),
            new quadruple ('AL_FBDC0S2TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot2Temperature, new Point (101, 45)),
            new quadruple ('AL_FBDC1S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot0Temperature, new Point (101, 45)),
            new quadruple ('AL_FBDC1S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot1Temperature, new Point (101, 45)),
            new quadruple ('AL_FBDC1S2TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot2Temperature, new Point (101, 45)),
            new quadruple ('AL_FBDC2S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot0Temperature, new Point (70, 44)),
            new quadruple ('AL_FBDC2S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot1Temperature, new Point (70, 44)),
            new quadruple ('AL_FBDC2S2TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot2Temperature, new Point (70, 44)),
            new quadruple ('AL_FBDC3S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot0Temperature, new Point (70, 44)),
            new quadruple ('AL_FBDC3S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot1Temperature, new Point (70, 44)),
            new quadruple ('AL_FBDC3S2TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot2Temperature, new Point (70, 44)),
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature1, new Point (101, 81)),
            new quadruple ('AL_CPU1TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature2, new Point (101, 81)),
            new quadruple ('AL_CPU2TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature1, new Point (77, 81)),
            new quadruple ('AL_CPU2TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature2, new Point (77, 81)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage, new Point (101, 81)),
            new quadruple ('AL_VCORE2', parent.asID['IDV_TYPE_SNR'], snridVcore2Voltage, new Point (77, 81)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (48, 81)),
            new quadruple ('AL_MBTEMP2', parent.asID['IDV_TYPE_SNR'], snridMBTemperature2, new Point (48, 81)),
            new quadruple ('AL_BACKPLANE1', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (84, 184))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 13, 172,  57, 193), compPowerFan1),
            new AnArea (new Rect ( 13, 195,  57, 216), compPowerFan2),
            new AnArea (new Rect ( 11, 169,  77, 217), compRedundantPower),
            new AnArea (new Rect ( 77, 191, 171, 215), compIOConnector)
        ),
        new Tuple (
            new quadruple ('AL_POWERS', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_POWERS'], new Point (35, 185)),
            new quadruple ('AL_POWERFAN1', parent.asID['IDV_TYPE_SNR'], snridPowerFan1, new Point (26, 174)),
            new quadruple ('AL_POWERFAN2', parent.asID['IDV_TYPE_SNR'], snridPowerFan2, new Point (26, 197))
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('h',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? 'BP8LX-R22' : '')"
    ),

    new GSysViewHealth ('f',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? 'BP8LX-R22' : '')",
        "parent.I18N['BACKPLANE_NUMBER']", "1",
        "parent.I18N['USB_PORT']", "2"
    ),
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2",
        "parent.I18N['POWERMODULE']", "2"

    )
);


//////////////////////////////////////////////
// The System Backplane and Power structure

var theSysBackplane = new Array ();

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE1']] = new SysBackplane (
    'BP8LX-R22', 'h_bp.jpg', compBackplane,
    new Tuple,
    new Tuple (
        new Tuple (snridBkpl1Bay1Plug),
        new Tuple (snridBkpl1Bay2Plug),
        new Tuple (snridBkpl1Bay3Plug),
        new Tuple (snridBkpl1Bay4Plug),
        new Tuple (snridBkpl1Bay5Plug),
        new Tuple (snridBkpl1Bay6Plug),
        new Tuple (snridBkpl1Bay7Plug),
        new Tuple (snridBkpl1Bay8Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE1'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);

var theSysPower = new SysPower (
    '_', compRedundantPower,
    new Tuple (
        new Tuple (snridPower1Plug, snridPower1AC, snridPowerFan1),
        new Tuple (snridPower2Plug, snridPower2AC, snridPowerFan2)
    ),
    false
);
